SPROX_DESFIRE_DIR:=$(SOURCE_DIR)/cardware/desfire
SPROX_MIFULC_DIR:=$(SOURCE_DIR)/cardware/mifulc
SPROX_MIFPLUS_DIR:=$(SOURCE_DIR)/cardware/mifplus
SPROX_CALYPSO_DIR:=$(SOURCE_DIR)/cardware/calypso
SPROX_HIDSIO_DIR:=$(SOURCE_DIR)/cardware/hidsio

SPROX_DESFIRE_SRCS:=	\
	$(SPROX_DESFIRE_DIR)/sprox_desfire_aes.c \
	$(SPROX_DESFIRE_DIR)/sprox_desfire_auth.c \
	$(SPROX_DESFIRE_DIR)/sprox_desfire_cipher.c \
	$(SPROX_DESFIRE_DIR)/sprox_desfire_cmac.c \
	$(SPROX_DESFIRE_DIR)/sprox_desfire_core.c \
	$(SPROX_DESFIRE_DIR)/sprox_desfire_crc.c \
	$(SPROX_DESFIRE_DIR)/sprox_desfire_des.c \
	$(SPROX_DESFIRE_DIR)/sprox_desfire_files.c \
	$(SPROX_DESFIRE_DIR)/sprox_desfire_iso.c \
	$(SPROX_DESFIRE_DIR)/sprox_desfire_keys.c \
	$(SPROX_DESFIRE_DIR)/sprox_desfire_mac.c \
	$(SPROX_DESFIRE_DIR)/sprox_desfire_mgmt.c \
	$(SPROX_DESFIRE_DIR)/sprox_desfire_msg.c \
	$(SPROX_DESFIRE_DIR)/sprox_desfire_pcsc.c \
	$(SPROX_DESFIRE_DIR)/sprox_desfire_rand.c \
	$(SPROX_DESFIRE_DIR)/sprox_desfire_read.c \
	$(SPROX_DESFIRE_DIR)/sprox_desfire_records.c \
	$(SPROX_DESFIRE_DIR)/sprox_desfire_reentrant.c \
	$(SPROX_DESFIRE_DIR)/sprox_desfire_trans.c \
	$(SPROX_DESFIRE_DIR)/sprox_desfire_value.c \
	$(SPROX_DESFIRE_DIR)/sprox_desfire_wrap.c \
	$(SPROX_DESFIRE_DIR)/sprox_desfire_write.c

_SPROX_DESFIRE_OBJS:=$(patsubst %.c,%.$(OBJEXT),$(SPROX_DESFIRE_SRCS))
SPROX_DESFIRE_OBJS:=$(subst $(SOURCE_DIR),$(OBJECT_DIR),$(_SPROX_DESFIRE_OBJS))

SPROX_MIFULC_SRCS:=	\
	$(SPROX_MIFULC_DIR)/sprox_mifulc_des.c \
	$(SPROX_MIFULC_DIR)/sprox_mifulc_func.c \
	$(SPROX_MIFULC_DIR)/sprox_mifulc_pcsc.c \
	$(SPROX_MIFULC_DIR)/sprox_mifulc_rand.c

_SPROX_MIFULC_OBJS:=$(patsubst %.c,%.$(OBJEXT),$(SPROX_MIFULC_SRCS))
SPROX_MIFULC_OBJS:=$(subst $(SOURCE_DIR),$(OBJECT_DIR),$(_SPROX_MIFULC_OBJS))

SPROX_MIFPLUS_SRCS:=	\
	$(SPROX_MIFPLUS_DIR)/sprox_mifplus_aes.c \
	$(SPROX_MIFPLUS_DIR)/sprox_mifplus_auth.c \
	$(SPROX_MIFPLUS_DIR)/sprox_mifplus_cipher.c \
	$(SPROX_MIFPLUS_DIR)/sprox_mifplus_cmac.c \
	$(SPROX_MIFPLUS_DIR)/sprox_mifplus_level0.c \
	$(SPROX_MIFPLUS_DIR)/sprox_mifplus_level3.c \
	$(SPROX_MIFPLUS_DIR)/sprox_mifplus_pcsc.c \
	$(SPROX_MIFPLUS_DIR)/sprox_mifplus_rand.c \
	$(SPROX_MIFPLUS_DIR)/sprox_mifplus_utils.c \
	$(SPROX_MIFPLUS_DIR)/sprox_mifplus_vc.c

_SPROX_MIFPLUS_OBJS:=$(patsubst %.c,%.$(OBJEXT),$(SPROX_MIFPLUS_SRCS))
SPROX_MIFPLUS_OBJS:=$(subst $(SOURCE_DIR),$(OBJECT_DIR),$(_SPROX_MIFPLUS_OBJS))

SPROX_CALYPSO_SRCS:=	\
	$(SPROX_CALYPSO_DIR)/calypso_strings.c \
	$(SPROX_CALYPSO_DIR)/readers/calypso_reader_abstract.c \
	$(SPROX_CALYPSO_DIR)/readers/calypso_reader_pcsc.c \
	$(SPROX_CALYPSO_DIR)/entries/calypso_entries_pc.c \
	$(SPROX_CALYPSO_DIR)/entries/calypso_explorer.c \
	$(SPROX_CALYPSO_DIR)/entries/calypso_get_info.c \
	$(SPROX_CALYPSO_DIR)/functions/calypso_card_commands.c \
	$(SPROX_CALYPSO_DIR)/functions/calypso_card_manage.c \
	$(SPROX_CALYPSO_DIR)/functions/calypso_card_pin.c \
	$(SPROX_CALYPSO_DIR)/functions/calypso_card_read.c \
	$(SPROX_CALYPSO_DIR)/functions/calypso_card_session.c \
	$(SPROX_CALYPSO_DIR)/functions/calypso_card_write.c \
	$(SPROX_CALYPSO_DIR)/functions/calypso_sam_commands.c \
	$(SPROX_CALYPSO_DIR)/functions/calypso_storedvalue.c \
	$(SPROX_CALYPSO_DIR)/functions/calypso_transaction.c \
	$(SPROX_CALYPSO_DIR)/intercode/calypso_intercode_datetime.c \
	$(SPROX_CALYPSO_DIR)/intercode/calypso_intercode_from_struct.c \
	$(SPROX_CALYPSO_DIR)/intercode/calypso_intercode_to_struct.c \
	$(SPROX_CALYPSO_DIR)/intercode/calypso_intercode_to_xml_core.c \
	$(SPROX_CALYPSO_DIR)/intercode/calypso_intercode_to_xml_pc.c \
	$(SPROX_CALYPSO_DIR)/others/calypso_bench_pc.c \
	$(SPROX_CALYPSO_DIR)/others/calypso_info_to_xml.c \
	$(SPROX_CALYPSO_DIR)/others/calypso_atr_to_xml.c \
	$(SPROX_CALYPSO_DIR)/others/calypso_pc_binconvert.c \
	$(SPROX_CALYPSO_DIR)/others/calypso_pc_trace.c \
	$(SPROX_CALYPSO_DIR)/others/calypso_pc_datetime.c \
	$(SPROX_CALYPSO_DIR)/parsers/calypso_parser_asn1.c \
	$(SPROX_CALYPSO_DIR)/parsers/calypso_parser_atr.c \
	$(SPROX_CALYPSO_DIR)/parsers/calypso_parser_fci.c \
	$(SPROX_CALYPSO_DIR)/parsers/calypso_parser_finfo.c

_SPROX_CALYPSO_OBJS:=$(patsubst %.c,%.$(OBJEXT),$(SPROX_CALYPSO_SRCS))
SPROX_CALYPSO_OBJS:=$(subst $(SOURCE_DIR),$(OBJECT_DIR),$(_SPROX_CALYPSO_OBJS))

SPROX_HIDSIO_SRCS:=	\
	$(SPROX_HIDSIO_DIR)/hidsio_cardinfo.c \
	$(SPROX_HIDSIO_DIR)/hidsio_contactless.c \
	$(SPROX_HIDSIO_DIR)/hidsio_dispatcher.c \
	$(SPROX_HIDSIO_DIR)/hidsio_entries_pcsc.c \
	$(SPROX_HIDSIO_DIR)/hidsio_pac.c \
	$(SPROX_HIDSIO_DIR)/hidsio_pcsc.c \
	$(SPROX_HIDSIO_DIR)/hidsio_picopass.c \
	$(SPROX_HIDSIO_DIR)/hidsio_sam.c \
	$(SPROX_HIDSIO_DIR)/hidsio_tlv_maker.c \
	$(SPROX_HIDSIO_DIR)/hidsio_tlv_parser.c

_SPROX_HIDSIO_OBJS:=$(patsubst %.c,%.$(OBJEXT),$(SPROX_HIDSIO_SRCS))
SPROX_HIDSIO_OBJS:=$(subst $(SOURCE_DIR),$(OBJECT_DIR),$(_SPROX_HIDSIO_OBJS))
