#ifndef __NFC_H__
#define __NFC_H__

#ifdef WIN32
#define _CRT_SECURE_NO_WARNINGS
#include <windows.h>
#endif

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#ifdef __linux__
#include <unistd.h>
#endif

#include <winscard.h>

#ifndef FALSE
  #define FALSE 0
#endif
#ifndef TRUE
  #define TRUE 1
#endif

#include "nfc_tag.h"
#include "nfc_tag_smartposter.h"
#include "nfc_ndef.h"
#include "nfc_rtd_uri.h"
#include "nfc_rtd_text.h"
#include "nfc_card.h"
#include "nfc_utils.h"

void nfc_list_readers(void);
const char *nfc_reader_find(const char *reader_name);
BOOL nfc_reader_is_card_present(const char *reader_name);
BOOL nfc_reader_wait_card_present(const char *reader_name);
BOOL nfc_reader_wait_card_absent(const char *reader_name);
BOOL nfc_reader_set_leds(const char *reader_name, BYTE red, BYTE green, BYTE blue);
BOOL nfc_reader_set_leds_default(const char *reader_name);
BOOL nfc_reader_start_emul(const char *reader_name);
BOOL nfc_reader_stop_emul(const char *reader_name);
BOOL nfc_reader_exit_with_emul(const char *reader_name);

#define NFC_NDEF_VERSION_1            0x10
#define NFC_NDEF_VERSION_2            0x20

#define NFC_NDEF_7816_AID             { 0xD2, 0x76, 0x00, 0x00, 0x85, 0x01, 0x01 }

#define NFC_NDEF_DESFIRE_DF_ID        0xEEEE10
#define NFC_NDEF_DESFIRE_CC_EF_ID     0x03
#define NFC_NDEF_DESFIRE_DATA_EF_ID   0x04

#define NFC_NDEF_7816_DF_ID           0xE100
#define NFC_NDEF_7816_CC_EF_ID        0xE103
#define NFC_NDEF_7816_DATA_EF_ID      0xE104

#define NDEF_FILE_CONTROL_TAG         0x04
#define NDEF_FILE_CONTROL_LEN         0x06
#define NDEF_MESSAGE_TAG              0x03
#define TERMINATOR_MESSAGE_TAG        0xFE

#define MAX_NFC_TAG_SIZE 128*1024

extern BOOL nfc_verbose;
extern BOOL nfc_silent;

#endif
