using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

using SpringCardPCSC;

namespace CalypsoExplorer
{
  public partial class fReaderSelect : Form
  {
    private string _SelectedReader = "";
  
    public string SelectedReader()
    {
      return _SelectedReader;
    }
  
    public fReaderSelect()
    {
      InitializeComponent();
    }

    private void LoadReaderList()
    {
      int i;
      
      listView.BeginUpdate();
      listView.Items.Clear();
      
      string [] readers = SCARD.Readers;
      
      for (i=0; i<readers.Length; i++)
        listView.Items.Add(readers[i]);
        
      if (listView.Items.Count == 0)
      {

      } else
      if (listView.Items.Count == 1)
      {
        listView.Items[0].Selected = true;
      } else
      {
        for (i=0; i<listView.Items.Count; i++)
        {
          if ((listView.Items[i].Text.Contains("SpringCard"))
           && (listView.Items[i].Text.Contains("ontactless")))
          {
            listView.Items[i].Selected = true;
            break;
          }
        }
      }
     
      if (listView.Items.Count == 0)
      {
        lbReaderCaption.Text = "No reader found.";
        timerRefresh.Enabled = true;
      } else
      {
        lbReaderCaption.Text = "Select the smartcard reader to access the Calypso card";
      }    

      if (listView.SelectedItems.Count == 1)
      {
        btnOK.Enabled = true;
        btnOK.Select();
      } else
      {
        btnOK.Enabled = false;
      }
      
      listView.EndUpdate();
    }
    
    private void fReader_Shown(object sender, EventArgs e)
    {
      LoadReaderList();
    }

    private void listView_DoubleClick(object sender, EventArgs e)
    {
      if (listView.SelectedItems.Count == 1)
      {
        _SelectedReader = listView.SelectedItems[0].Text;
        DialogResult = DialogResult.OK;
      }
    }

    private void timerRefresh_Tick(object sender, EventArgs e)
    {
      timerRefresh.Enabled = false;
      LoadReaderList();
    }

    private void checkBoxNoReader_CheckedChanged(object sender, EventArgs e)
    {
      if (checkBoxNoReader.Checked)
      {
        listView.Enabled = false;
        btnOK.Enabled = true;
      } else
      {
        listView.Enabled = true;
        if (listView.Items.Count == 1)
        {
          listView.Items[0].Selected = true;
          btnOK.Enabled = true;
        } else
        {
          btnOK.Enabled = false;        
        }
      }
    }
    
    private void listView_SelectedIndexChanged(object sender, EventArgs e)
    {
      if (listView.SelectedItems.Count == 1)
      {
        btnOK.Enabled = true;
      } else
      {
        btnOK.Enabled = checkBoxNoReader.Checked;
      }
    }

    private void btnOK_Click(object sender, EventArgs e)
    {
      if (checkBoxNoReader.Checked)
      {
        _SelectedReader = "";
      } else
      if (listView.SelectedItems.Count == 1)
      {
        _SelectedReader = listView.SelectedItems[0].Text;
      }
    }
  }
}