﻿/*
 * Created by SharpDevelop.
 * User: jerome.i
 * Date: 21/06/2013
 * Time: 16:08
 * 
 * To change this template use Tools | Options | Coding | Edit Standard Headers.
 */
using System;
using System.Drawing;
using System.Windows.Forms;
using SpringCardPCSC;
using SpringCardMemoryCard;
using SpringCardApplication;

namespace MemoryCardTool
{
	/// <summary>
	/// Description of UnlockForm.
	/// </summary>
	public partial class UnlockForm : Form
	{
		SectorControl sectorControl;
		Settings settings;
		
		public UnlockForm(Settings _settings, SectorControl _sectorControl)
		{
			InitializeComponent();
			settings = _settings;
			sectorControl = _sectorControl;

			string[] lastKeyAs = settings.LastKeyAs();
			for (int i = 0; i < lastKeyAs.Length ; i++)
				cbKeyA.Items.Add(lastKeyAs[i]);		
			
			if (cbKeyA.Items.Count > 0)
				cbKeyA.SelectedIndex = 0;
			
			string[] lastKeyBs = settings.LastKeyBs();
			for (int i = 0; i < lastKeyBs.Length ; i++)
				cbKeyB.Items.Add(lastKeyBs[i]);		
			
			if (cbKeyB.Items.Count > 0)
				cbKeyB.SelectedIndex = 0;
			
		}
		

		
		void BtOkClick(object sender, EventArgs e)
		{
			if (cbKeyA.Text.Equals("") && cbKeyB.Text.Equals(""))
			{
				MessageBox.Show("Both Keys can't be null", "Error", MessageBoxButtons.OK, MessageBoxIcon.Error);
				this.DialogResult = DialogResult.None;
				return;
			}
			
			if (!cbKeyA.Text.Equals(""))
			{
				if (!MifareSector.checkCorrectFormat(cbKeyA.Text, 6))
				{
					MessageBox.Show("Key A is incorrect (6 hexadecimal bytes awaited)", "Error", MessageBoxButtons.OK, MessageBoxIcon.Error);
					this.DialogResult = DialogResult.None;
					return;
				}
				CardBuffer keyA = new CardBuffer(cbKeyA.Text);
				sectorControl.setKeyA(keyA.GetBytes());
				settings.RememberKeyA(cbKeyA.Text);
			}
					
			
			if (!cbKeyB.Text.Equals(""))
			{
				if (!MifareSector.checkCorrectFormat(cbKeyB.Text, 6))
				{
					MessageBox.Show("Key B is incorrect (6 hexadecimal bytes awaited)", "Error", MessageBoxButtons.OK, MessageBoxIcon.Error);
					this.DialogResult = DialogResult.None;
					return;
				}
								
				CardBuffer keyB = new CardBuffer(cbKeyB.Text);
				sectorControl.setKeyB(keyB.GetBytes());
				settings.RememberKeyB(cbKeyB.Text);
			}
			
			
		
		}
		
	}
	
}
