﻿Imports SpringCardPCSC

Public Class Form1

    Dim reader As SCardReader
    Dim cardchannel As SCardChannel

    Private Sub Form1_Shown(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Shown
        UpdateReadersList()
    End Sub

    Private Sub UpdateReadersList()
        cbReaders.Items.Clear()
        cbReaders.Text = ""
        lbCurrentStatus.Text = ""
        Dim readers() As String = SCARD.Readers()

        If Not IsNothing(readers) Then
            For Each reader As String In readers
                cbReaders.Items.Add(reader)
            Next

            If cbReaders.Items.Count >= 0 Then
                cbReaders.SelectedIndex = 0
            End If

            For i = 0 To cbReaders.Items.Count - 1
                If cbReaders.Items(i).ToString().Contains("SpringCard") Then
                    cbReaders.SelectedIndex = i
                End If

            Next
        End If

    End Sub


    Private Sub cbReaders_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cbReaders.SelectedIndexChanged
        If Not IsNothing(reader) Then
            reader.StopMonitor()
        End If

        reader = New SCardReader(cbReaders.Items(cbReaders.SelectedIndex).ToString)
        reader.StartMonitor(New SCardReader.StatusChangeCallback(AddressOf ReaderStatusChanged))

    End Sub

    Private Delegate Sub ReaderStatusChangedInvoker(ByVal ReaderState As UInteger, ByVal CardAtr As CardBuffer)
    Private Sub ReaderStatusChanged(ByVal ReaderState As UInteger, ByVal CardAtr As CardBuffer)
        If InvokeRequired Then
            BeginInvoke(New ReaderStatusChangedInvoker(AddressOf ReaderStatusChanged), ReaderState, CardAtr)
            Return
        End If
        lbCurrentStatus.Text = SCARD.ReaderStatusToString(ReaderState)

        If IsNothing(CardAtr) Then
            lbATr.Text = ""
            lbUID.Text = ""
        Else
            lbATr.Text = CardAtr.AsString(" ")
            cardchannel = New SCardChannel(reader)
            Dim capdu As CAPDU = New CAPDU(&HFF, &HCA, &H0, &H0)
            If (Not cardchannel.Connect()) Then
                'MessageBox.Show("Can't connect to card")
                Return
            End If

            Dim rapdu As RAPDU = cardchannel.Transmit(capdu)
            If (Not rapdu.SW = &H9000) Then
                lbUID.Text = "'Get UID' APDU has failed"
                lbUID.ForeColor = Color.Red
            Else
                Dim rapdu_bytes() As Byte = rapdu.data.GetBytes()
                Dim uid As String = ""
                For i As Integer = 0 To (rapdu.data.GetBytes().Length - 1)
                    uid += String.Format("{0:x02}", rapdu.data.GetByte(i)).ToUpper() + " "
                Next
                lbUID.Text = uid
                lbUID.ForeColor = Color.Green
            End If
            End If



    End Sub


    Private Sub btUpdate_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btUpdate.Click
        UpdateReadersList()
    End Sub


    Private Sub AboutToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles AboutToolStripMenuItem.Click
        Dim about As AboutForm = New AboutForm()
        about.ShowDialog()
    End Sub

    Private Sub CloseToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles CloseToolStripMenuItem.Click
        Close()
        Dispose()
    End Sub
End Class
