#ifndef __QUICKBATCH_H__
#define __QUICKBATCH_H__

#include <windows.h>
#include <winscard.h>
#include <stdio.h>
#include <string.h>
#include <stdlib.h>

void list_pcsc_readers(void);
char *pcsc_reader_find(char *reader_name);
BOOL pcsc_is_card_present(char *reader_name);
BOOL pcsc_wait_card_present(char *reader_name);
BOOL pcsc_wait_card_absent(char *reader_name);

typedef struct _smartcard_st *smartcard_t;

smartcard_t pcsc_connect(char *reader_name);
smartcard_t pcsc_connect_direct(char *reader_name);
BOOL pcsc_disconnect(smartcard_t card);
BOOL pcsc_transmit(smartcard_t card, const unsigned char capdu[], unsigned long capdu_length, unsigned char rapdu[], unsigned long *rapdu_length);
BOOL pcsc_control(smartcard_t card, const unsigned char capdu[], unsigned long capdu_length, unsigned char rapdu[], unsigned long *rapdu_length);
SCARDHANDLE smartcard_pcsc_handle(smartcard_t card);

BOOL smartcard_get_uid(smartcard_t card, BYTE uid[], BYTE *uidlen);
BOOL smartcard_read_memory(smartcard_t card, unsigned short address, unsigned char buffer[], unsigned char length);

BOOL control_select_card_types(smartcard_t card, BOOL iso_14443a, BOOL iso_14443b);

BOOL springcard_suspend_tracking(smartcard_t card);
BOOL springcard_resume_tracking(smartcard_t card);
BOOL springcard_wait_card_present(smartcard_t card);
BOOL springcard_wait_card_absent(smartcard_t card);

extern BOOL be_verbose;
extern BOOL be_silent;

#endif
